/***************************************************************************
                          cost.h  -  description
                             -------------------

    functionality        : for computing MDL-related measures
    relevant classes     : vindex, tindex
    relevant functions   : compute_cost, calcula_partv

    begin                : 9-Oct-2001
    copyright            : (C) 2001-2002 by Cesar Ferri, Jose Hernandez
    email                : {cferri,jorallo}@dsic.upv.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <vector>
#include <string>
#include "exemples.h"
#include "estructures.h"
#include <math.h>
#include <stdio.h>

#ifndef COST_H
#define COST_H


/* vector per a magatzenar informaci sobre l'existencia de indexs  de forma eficient*/
/* es magatzena coma bitarray*/

class vindex
{
  bit_vector table;
 public:
  int cant;

  vindex (discrete a):table(a,false){cant=0;};

  void set_index(discrete arg)
    {
      if (table[(int)arg]==false)
			{
	  			table[(int)arg]=true;
	  			cant++;
			}

    }
};

typedef vector<vindex> tindex;

double compute_cost(const dataset &dt,const tindex  & ttaula,const exetablet   & itaula,int nej);
double calcula_partv(const vector<bool>  &OV);
#endif
