/***************************************************************************
                          options.cpp  -  description
                             -------------------

    functionality        : defines many options and the option class
    relevant classes     : options
    relevant functions   : default_options, hardwired_options, trau_opcions

    begin                : Sat Oct 27 2001
    copyright            : (C) 2001 by Cesar Ferri, Jose Hernandez
    email                : {cferri,jorallo}@dsic.upv.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <cstdlib>
#include "options.h"
#include <cstring>
#include "getopt.h"
#include <iostream>

#include "options-file.h"

void usage(char *prog, char *opt);

void default_options(options &Options) {
    // Options.ExpectedError.Method= NO_COMPUTE;
   // Options.ExpectedError.Method= RELATIVE_FREQUENCY_WITH_MAJORITY_CLASS;
   Options.ExpectedError.Method= RELATIVE_FREQUENCY_WITH_FREQ_PROB;
   //  Options.ExpectedError.Method= COST_WITH_MINIMUM_CLASS;
   // Options.ExpectedError.Method=  COST_WITH_FREQ_PROB;
   // Options.ExpectedError.Method= COST_WITH_COST_PROB;

  //  Options.Smoothing.Method= NO_SMOOTHING;
    Options.Smoothing.Method= LAPLACE;
  //   Options.Smoothing.Method= K_ESTIMATE        Options.Smoothing.m= 5;
  //   Options.Smoothing.Method= M_ESTIMATE;            Options.Smoothing.m= 5;
   //  Options.Smoothing.Method= M_ESTIMATE_UNIFORM;    Options.Smoothing.m= 5;

    //  Options.NodeSmoothing.Method= NO_SMOOTHING;
    Options.NodeSmoothing.Method= LAPLACE;
  //   Options.NodeSmoothing.Method= M_ESTIMATE;            Options.NodeSmoothing.m= 5;
   //  Options.NodeSmoothing.Method= M_ESTIMATE_UNIFORM;    Options.NodeSmoothing.m= 5;  // These last two options are equivalent



  // Options.ProbabilityInSplittingCriteria = FROM_FREQUENCY_NO_SMOOTHING;
    Options.ProbabilityInSplittingCriteria = FROM_FREQUENCY_SMOOTHING;
 //   Options.ProbabilityInSplittingCriteria = FROM_COSTS;
  //   Options.ProbabilityInSplittingCriteria = FROM_FREQUENCY_WITH_STRATIFICATION;
   //   Options.ProbabilityInSplittingCriteria = FROM_FREQUENCY_WITH_STRATIFICATION_NO_SMOOTHING;

   Options.Output.ShowRulesMode= FUNCLOGIC;	               // Not used
   // Options.Output.ShowRulesMode= IF_THEN_ELSE;          // Not used
   // Options.Output.ShowRulesMode= FUNCLOGIC_SIMPLIFIED;  // Not Used


   Options.Output.ShowClassDist= NO;      // Not used
   // Options.Output.ShowClassDist= YES;  // Not used

     Options.Output.ShowAllMultiTreeRules= NO_SHOW_ALL_RULES;
   // Options.Output.ShowAllMultiTreeRules= SHOW_ALL_RULES;
  // Options.Output.ShowAllMultiTreeRules= ALL_FILES_TO_FILE;  // Not implemented

   Options.Output.ShowAllKBestSolutions= NO_SHOW_SOLUTIONS;
  // Options.Output.ShowAllKBestSolutions= SHOW_SOLUTIONS;
  // Options.Output.ShowAllKBestSolutions= ALL_SOLUTIONS_TO_FILE;/  / Not implemented

  // Options.Output.ShowSolutionsComponents = SHOW_COMPONENTS;
   Options.Output.ShowSolutionsComponents = NO_SHOW_COMPONENTS;

   Options.Output.ShowStatistics= JUST_ACCURACY;
  // Options.Output.ShowStatistics = ABSOLUTE_STATISTICS;
  // Options.Output.ShowStatistics = RELATIVE_STATISTICS;
  // Options.Output.ShowStatistics = BOTH_STATISTICS;

   Options.Output.ShowConfusionMatrix = SHOW_CONFUSION_MATRIX;
  // Options.Output.ShowConfusionMatrix = NO_SHOW_CONFUSION_MATRIX;
  // Options.Output.ShowConfusionMatrix = ONLY_IF_COSTS;

   // Options.Output.ComputeROCPoints= NO_COMPUTE_ROC_POINTS;
   Options.Output.ComputeROCPoints= COMPUTE_ROC_POINTS;

    Options.Output.ShowROCPoints= NO_SHOW_ROC_POINTS;
   // Options.Output.ShowROCPoints= SHOW_ROC_POINTS;

   // Options.Output.ComputeROCArea= NO_COMPUTE_ROC_AREA;
   Options.Output.ComputeROCArea= COMPUTE_ROC_AREA_BY_HAND;

   // Options.Output.GenerateROCCurveFile= NO_GENERATE_ROC_CURVE_FILE;

   Options.Output.GenerateROCCurveFile= GENERATE_ROC_CURVE_FILE;


   // Options.Multitree.Construction= ONE_ONLY;
    Options.Multitree.Construction= MANY_AND_MAINTAIN;
   // Options.Multitree.Construction= ONE_AND_FORGET;


   Options.Multitree.SuspendedNodesForgetting = MAINTAIN_ALL;
   // Options.Multitree.SuspendedNodesForgetting = MAINTAIN_LOG_RANDOM;
   // Options.Multitree.SuspendedNodesForgetting = MAINTAIN_CONST_RANDOM;
   // Options.Multitree.SuspendedNodesForgetting = MAINTAIN_LOG_RANDOM_WITH_DEPTH;
   // Options.Multitree.SuspendedNodesForgetting = MAINTAIN_LOG_RANDOM_WITH_SQUARED_DEPTH;
   // Options.Multitree.SuspendedNodesForgetting = MAINTAIN_LOG_RANDOM_WITH_DEPTH_ADJUSTED;
   Options.Multitree.SuspendedNodesConstMaintain= 10;

   Options.Multitree.MaxNumTrees= 100;

   Options.Multitree.BestTreeCrit= OCCAM_BEST;
	 //Options.Multitree.BestTreeCrit= TEST_COST_BEST;
	 	 //Options.Multitree.BestTreeCrit= COVERAGE_BEST;
   // Options.Multitree.BestTreeCrit= CROSS_COVERAGE;
    //  Options.Multitree.BestTreeCrit= EXPECTED_ERROR_BEST;
   // Options.Multitree.BestTreeCrit= SPLIT_OPTIMALITY_BEST;
    // Options.Multitree.BestTreeCrit= MDL_BEST;

  // Options.Multitree.SecondTreeCrit.Met= OPTIMALITY_RIVAL_RATIO;
  // Options.Multitree.SecondTreeCrit= second_tree_criterion(OPTIMALITY_RIVAL_RATIO_DEPTH, 50);
  // Options.Multitree.SecondTreeCrit= second_tree_criterion(OPTIMALITY_RIVAL_RATIO_COMPONENT, 40);
  // Options.Multitree.SecondTreeCrit= second_tree_criterion(OPTIMALITY_RIVAL_RATIO_COMPONENT_RANDOM,10);
   Options.ComponentsRandomFactor= 0.5;
  //  Options.Multitree.SecondTreeCrit.Met=SPLIT_OPTIMALITY;
    Options.Multitree.SecondTreeCrit.Met= SECOND_TOPMOST;
  // Options.Multitree.SecondTreeCrit.Met= SECOND_BOTTOMMOST;
  //  Options.Multitree.SecondTreeCrit.Met=SECOND_RANDOM;
  // Options.Multitree.SecondTreeCrit.Met=SECOND_FRONT;
  // Options.Multitree.SecondTreeCrit.Met=SECOND_BACK;
  //   Options.Multitree.SecondTreeCrit= second_tree_criterion(SECOND_RANDOM_DEPTH, 0.1);

   Options.Components_In_Split_Criterion.Met= NO_USE_OF_COMPONENT_IN_SPLIT;
  // Options.Components_In_Split_Criterion= components_in_split_criterion(ADAPTATIVE_COMPONENT,20);
  // Options.Components_In_Split_Criterion= components_in_split_criterion(RANDOM_COMPONENTS,2);


    if ((Options.Components_In_Split_Criterion.Met == ADAPTATIVE_COMPONENT)
         || (Options.Components_In_Split_Criterion.Met == RANDOM_COMPONENTS)
         || (Options.Multitree.SecondTreeCrit.Met == OPTIMALITY_RIVAL_RATIO_COMPONENT)
         || (Options.Multitree.SecondTreeCrit.Met == OPTIMALITY_RIVAL_RATIO_COMPONENT_RANDOM))
      Options.Components_Reckoning= true; // true if component matrix is to be used. Put false instead.
    else
      Options.Components_Reckoning= false;


    Options.SelectKBest.NumSolutions = 1;

    Options.SelectKBest.Met = K_BEST_LESS_VISITED;
    //  Options.SelectKBest.Met = K_BEST_LESS_VISITED_PLUS; // Not implemented
    // Options.SelectKBest.Met = K_BEST_LESS_VISITED_THEN_DIFFERENT_COMPONENTS;
    //  Options.SelectKBest.Met = K_BEST_DIFFERENT_COMPONENTS;
    //   Options.SelectKBest.Met = K_BEST_RANDOM;


    Options.SelectKBest.ComponentsGeneration = COMP_ACCUMULATE;
    //    Options.SelectKBest.ComponentsGeneration = COMP_RANDOM_GENERATE_FROM_START;
    //   Options.SelectKBest.ComponentsGeneration = COMP_RANDOM_GENERATE_FROM_SECOND;
    Options.SelectKBest.FactorForRandomComponents= 0.25;

    Options.IntervalCriterion=   numerical_interval_criterion(LOG, 5, 10.0); // Max number of intervals for a given argument = 2nd Argument + LOG BASE 3ND ARGUMENT OF NUMBER OF VALUES
                                  //  numerical_interval_criterion(MAX, 7); // Max number of intervals for a given argument
                                              // numerical_interval_criterion(NO_LIMIT);

    Options.SSC=                                        // DESC_MDL;
                                                                  // LEFT_FIRST;
                                                                  // GAIN;
                                                                 //  GAIN_RATIO;
                                                            C45;
                                                                // CART;
                                                               //  DKM;
                                                           //    SPLIT_EXPECTED_ERROR;
                                                           // LOCAL_ROC_AREA;
                                                           // ONE_POINT_LOCAL_ROC_AREA;
                                                           // MSE_SPLIT
                                                           //  LOGLOSS_SPLIT
                                                           //AUCH_SPLIT
                                                           // SQDIF_SPLIT
                                                           // MGINI_SPLIT
                                                           // GENENTROPY_SPLIT
                                                           // ROCV_SPLIT



    Options.PC= pruning_criterion(NO_PRUNING);
                            //      pruning_criterion(PROPORTIONAL, 2.5, 3);   // El primer baix i el segon alt per a podar ms
                                                                          // en 2.5 i 3 dna 100% per al monks2
                          //              pruning_criterion(EXPECTED_ERROR_PRUNING, 1.05);  // Quan ms gran el factor ms poda.
                                 //  pruning_criterion(MDL_PRUNING, 0.995);  // Quan ms gran el factor ms poda.
      ///            pruning_criterion(STUMP_PRUNING, 3);
           //            Options.PC= pruning_criterion(PEP_PREPRUNING);   // Pessimistic Error Pruning (like Quinlan 1987 but pre-pruning)


    Options.PostPruningMethod= NO_POSTPRUNING;
    // Options.PostPruningMethod= PEP_POSTPRUNING;


    vector<bool> Part(4);  // A SERIA MILLOR UN CONJUNT.
    Part[PARTITION_MANY_CONST_EQ]= true;            // Partition X=a, X=b, X=c...
    Part[PARTITION_ONE_CONST_EQ]= false;            // Partition X=a, X!=a
    Part[PARTITION_ONE_VARIABLE_EQ]= true;          // Partition X=Y, X!=Y
    Part[PARTITION_ONE_CONST_DISEQ]= true;         // Partition X<c, X>=c

   Options.Enabled_Partitions= Part;


    Options.TestCostMethod= NO_TEST_COSTS;
//    Options.TestCostMethod= UNIFORM_TEST_COSTS;
//    Options.TestCostMethod= TEST_COSTS_FROM_FILE;


    Options.TestCostUse = TEST_COSTS_NO_USE;
//    Options.TestCostUse = TEST_COSTS_LINEAR_PLUS1_WITHOUT_REPETITION;
//    Options.TestCostUse = TEST_COSTS_LINEAR_PLUS1_WITH_REPETITION;


    Options.Weights.Method= NO_COSTS;
  //  Options.Weights.Method= UNIFORM_WEIGHTS;  // The same as NO_COSTS
  //  Options.Weights.Method= WEIGHTS_FROM_FILE;
  //  Options.Weights.Method= INVERSE_FREQUENCY_WEIGHTS;  Options.Weights.Parameter= 1.0;
   //  Options.Weights.Method= COSTS_FROM_MATRIX;

    Options.Weights.ClassSelection= MAJORITY_CLASS;
  //  Options.Weights.ClassSelection= MIN_COST_CLASS;
    // Options.Weights.ClassSelection = MIN_COST_CLASS_WITHOUT_SMOOTHING;
     //  Options.Weights.ClassSelection= STRATIFICATION_CLASS;
    //  Options.Weights.ClassSelection= STRATIFICATION_CLASS_WITHOUT_SMOOTHING;

   Options.Cost_Derived_Probability_Method = DIRECT;
  // Options.Cost_Derived_Probability_Method = WITH_SMOOTHING;


	// Options.Comb.Comb=NO_COMBINATION;	
  // Options.Comb.Comb= CROSS_COVERAGE_COMBINATION;
  // Options.Comb.Comb= MAJORITY_CRISP;
    Options.Comb.Comb= MAJORITY_ABSOLUT_STOCHASTIC;
  // Options.Comb.Comb= MAJORITY_RELATIVE_STOCHASTIC;
  // Options.Comb.Comb= MAJORITY_COST_STOCHASTIC;
	

   Options.Comb.Smoothing= true;

   Options.Comb.CombinationVector= ABSOLUTE;
  // Options.Comb.CombinationVector= RELATIVE;


   Options.Comb.CombinationVectorMethod= ORIGINAL;
   // Options.Comb.CombinationVectorMethod= GOOD_LOSER;
   // Options.Comb.CombinationVectorMethod= BAD_LOSER;
   // Options.Comb.CombinationVectorMethod= DIFFERENCE;
   // Options.Comb.CombinationVectorMethod= MAJORITY;
   // Options.Comb.CombinationVectorMethod= SQUARED;

   // Options.Comb.FusionMethod= SUM;
   // Options.Comb.FusionMethod= PROD;
   // Options.Comb.FusionMethod= ARITHMEAN;
   // Options.Comb.FusionMethod= GEOMEAN;
   Options.Comb.FusionMethod= MAXIMUM;
   // Options.Comb.FusionMethod= MINIMUM;
   // Options.Comb.FusionMethod= MEDIAN;


   Options.Comb.PruneInCombination= false;


//   Options.Comb2Single.SimilarityMethod = KAPPA;
   Options.Comb2Single.SimilarityMethod = KAPPA1;
//   Options.Comb2Single.SimilarityMethod = QSTAT;

   // Options.Comb2Single.Method = INVENTED_DATASET;
   Options.Comb2Single.Method = NO_EXTRACTION;
   Options.Comb2Single.InventedDataSetLength= 1000;

   Options.Comb2Single.SimilarityImportanceFactor= 1.0;
   Options.Comb2Single.OccamImportanceFactor= 0.0;
   Options.Comb2Single.TestCostImportanceFactor= 0.0;


   Options.SampleTrainingSet= NO_SAMPLE_TRAINING_SET;
   // Options.SampleTrainingSet= SAMPLE_TRAINING_SET;
   Options.SampleTrainingSetProportion= 0.5;

  Options.CrossValidation= USE_SEPARATE_TEST_SET;
  // Options.CrossValidation= CROSS_VALIDATION;
  // Options.CrossValidation= KFOLD_CROSS_VALIDATION;
  // Options.CrossValidation = REPEATED_KFOLD_CROSS_VALIDATION;

  Options.kFoldValidation= 10;

  Options.RepeatKFold= 1;

  Options.AllowTestWithoutOneClass= false;

  Options.MissingNumericValues= IGNORE_EXAMPLES_WITH_MISSING_NUMERIC_VALUES;
  // Options.MissingNumericValues= SUBSTITUTE_MISSING_NUMERIC_VALUES;
  Options.ShowNumberSolutions= DO_NOT_SHOW_NUMBER_SOLUTIONS;

  Options.ReliabilityCalculation= LAPLACE_RELIABILITY;
  // Options.ReliabilityCalculation= FREQUENCY_RELIABILITY;

  Options.ClassProbabilityVectorCalculation= LAPLACE_CLASS_PROBABILITY_VECTOR;
//  Options.ClassProbabilityVectorCalculation= FREQUENCY_CLASS_PROBABILITY_VECTOR;
}



void hardwired_options(options &Options) {
   Options.ComponentsRandomFactor= 0.75;

 //  Options.Multitree.SecondTreeCrit= second_tree_criterion(SECOND_RANDOM_DEPTH, 0.1);

   Options.Smoothing.m= 10;
   Options.NodeSmoothing.m=5;

   // Options.IntervalCriterion=   numerical_interval_criterion(LOG, 5, 10.0); // Max number of intervals for a given argument = 2nd Argument + LOG BASE 3ND ARGUMENT OF NUMBER OF VALUES
                                  //  numerical_interval_criterion(MAX, 7); // Max number of intervals for a given argument
                                              // numerical_interval_criterion(NO_LIMIT);


  Options.Components_In_Split_Criterion.Met= NO_USE_OF_COMPONENT_IN_SPLIT;
  // Options.Components_In_Split_Criterion= components_in_split_criterion(ADAPTATIVE_COMPONENT,20);
  // Options.Components_In_Split_Criterion= components_in_split_criterion(RANDOM_COMPONENTS,2);


    if ((Options.Components_In_Split_Criterion.Met == ADAPTATIVE_COMPONENT)
         || (Options.Components_In_Split_Criterion.Met == RANDOM_COMPONENTS)
         || (Options.Multitree.SecondTreeCrit.Met == OPTIMALITY_RIVAL_RATIO_COMPONENT)
         || (Options.Multitree.SecondTreeCrit.Met == OPTIMALITY_RIVAL_RATIO_COMPONENT_RANDOM))
      Options.Components_Reckoning= true; // true if component matrix is to be used. Put false instead.
    else
      Options.Components_Reckoning= false;


    Options.SelectKBest.FactorForRandomComponents= 0.25;


    Options.TestCostRelevanceInSplitting= 1; // must be from 0 to infinite.
    Options.TestCostRelevanceInSelectBest= 0.5; // must be from 0 to 1. USED ONLY IF OCCAM_AND_TEST_COST_BEST IS ENABLED

    //  ESTE SI Options.PC= pruning_criterion(NO_PRUNING);
     //           Options.PC= pruning_criterion(PROPORTIONAL, 2.5, 3);   // El primer baix i el segon alt per a podar ms
                                                                          // en 2.5 i 3 dna 100% per al monks2
                          //              pruning_criterion(EXPECTED_ERROR_PRUNING, 1.05);  // Quan ms gran el factor ms poda.
                                 //  pruning_criterion(MDL_PRUNING, 0.995);  // Quan ms gran el factor ms poda.
     // ESTE SI    Options.PC= pruning_criterion(STUMP_PRUNING, 3);
     //            Options.PC= pruning_criterion(PEP_PREPRUNING);   // Pessimistic Error Pruning (like Quinlan 1987 but pre-pruning)

    vector<bool> Part(4);  // A SERIA MILLOR UN CONJUNT.
    Part[PARTITION_MANY_CONST_EQ]= true;            // Partition X=a, X=b, X=c...
    Part[PARTITION_ONE_CONST_EQ]= false;            // Partition X=a, X!=a
    Part[PARTITION_ONE_VARIABLE_EQ]= false;          // Partition X=Y, X!=Y
    Part[PARTITION_ONE_CONST_DISEQ]= true;         // Partition X<c, X>=c

   Options.Enabled_Partitions= Part;
}

void trau_opcions( char *const  *argv,  const int argc, options &Options, string &ftrain, string &ftest, string &fcost, string &ftestcost, const string &defaultdataset, const string &defaultextension)
 {
//   long int  prof=1;
  char arg;

  while ((arg = getopt(argc, argv, "?")) != EOF)   // d:c:p:n:s:
    {
     switch (arg)
	{
	/*
	case 'c':
	{
	 	if ( strcmp(optarg,"left_first")==0) {criteri=LEFT_FIRST;break;}
	 	if ( strcmp(optarg, "gain")==0){criteri=GAIN;break;}
	 	if ( strcmp(optarg, "gain_ratio")==0){criteri=GAIN_RATIO;break;}
	 	if ( strcmp(optarg, "c45")==0){criteri=C45;break;}
 	 	if ( strcmp(optarg, "adj_gain")==0){criteri=ADJ_GAIN;break;}
	 	if ( strcmp(optarg, "adj_gain_ratio")==0){criteri=ADJ_GAIN_RATIO;break;}  					
	 	if ( strcmp(optarg, "c50")==0){criteri=C50;break;}
	 	if ( strcmp(optarg, "cart")==0){criteri=CART;break;}  					
	 	if ( strcmp(optarg, "desc_mdl")==0){criteri=DESC_MDL;break;}  				
	 	if ( strcmp(optarg, "weighted_desc_mdl")==0){criteri=WEIGHTED_DESC_MDL;break;}
	 	if ( strcmp(optarg, "split_expected_error")==0){criteri=SPLIT_EXPECTED_ERROR;break;}
     	 usage(argv[0], NULL);
		 break;
		}
	
	case 'p':
	   {
	   		if ( strcmp(optarg,"no_pruning")==0) {poda=NO_PRUNING;break;}
		 	else if ( strcmp(optarg,"proportional")==0) {poda=PROPORTIONAL;break;}            // FALTA EL PARAMETRE
	    		else if ( strcmp(optarg,"mdl_pruning")==0) {
	    		      poda=pruning_criterion(MDL_PRUNING,0.7);break;}//0.7 pareix anar be :-)
	    		else if ( strcmp(optarg,"expected_error_pruning")==0)
	    		   {//poda=EXPECTED_ERROR_PRUNING;
	    		  poda=pruning_criterion(EXPECTED_ERROR_PRUNING, 0.99);
	    		   break;}		// FALTA EL PARAMETRE				
              usage(argv[0], NULL);
	     	 break;
	 }
	
		case 'd':
	   {
	   		if ( strcmp(optarg,"occam_best")==0) {bcrit=OCCAM_BEST;break;}
		 	else if ( strcmp(optarg,"cross_coverage")==0) {bcrit=CROSS_COVERAGE;break;}
	    		else if ( strcmp(optarg,"expected_error_best")==0) {bcrit=EXPECTED_ERROR_BEST;break;}
	    		else if ( strcmp(optarg,"mdl_best")==0)	   {bcrit=MDL_BEST;break;}		
              usage(argv[0], NULL);
	     	 break;
	 }
	 case 's':
	   {
	   		if ( strcmp(optarg,"no_combination")==0) {Options.Comb=NO_COMBINATION;break;}
	 		if ( strcmp(optarg,"cross_coverage_combination")==0) {Options.Comb=CROSS_COVERAGE_COMBINATION;break;}
		 	if ( strcmp(optarg,"majority_crisp")==0) {Options.Comb=MAJORITY_CRISP;break;}
	    		if ( strcmp(optarg,"majority_absolut_stochastic")==0) {Options.Comb=MAJORITY_ABSOLUT_STOCHASTIC;break;}
	    		if ( strcmp(optarg,"majority_relative_stochastic")==0) {Options.Comb=MAJORITY_RELATIVE_STOCHASTIC;break;}		
	    		if ( strcmp(optarg,"majority_cost_stochastic")==0) {Options.Comb=MAJORITY_COST_STOCHASTIC;break;}
              usage(argv[0], NULL);
	     	 break;
		}

    case 'n':
	   { int i;

		 for(i=0;optarg[i];i++)
     	       if (!isdigit(optarg[i])) usage(argv[0],"invalid value in option 'p'");
        		  prof=strtol(optarg, (char **)NULL, 10);
        		  Options.Multitree.Construction = MANY_AND_MAINTAIN;
		if ((prof==1)||(prof==0)) Options.Multitree.Construction = ONE_ONLY;
		
          if ((prof==LONG_MIN)||(prof==LONG_MAX))
          usage(argv[0],"invalid value in option 'n'");
          break;
          }
		*/
	case '?':
	    usage(argv[0], NULL);
	    exit(0);
	    break;
	
	  }
}

 /*
  * Process the remaining command line arguments.
  */
 if (!argv[optind]) {
   cout << "Incorrect number of parameters. Training set not specified. " << endl;
   usage(argv[0],"");
   ftrain= defaultdataset + defaultextension;
   ftest= defaultdataset + ".test";
   fcost= defaultdataset + ".cost";
   ftestcost= defaultdataset + ".testcost";
   cout << endl << "Default training set, test set, cost matrix and test cost vector will be used: \"" <<
     ftrain << "\" , \"" << ftest << "\" and \"" << fcost << "\"" << endl;
   cout << endl;
   // Pause();
 }
 else {
   ftrain=argv[optind++];
   if (!argv[optind]) {
     // no hi ha ni test ni cost ni test cost
     // cerr << "Test set not specified. " << endl;  // NO PODEM PARAR PERQUE ELS CROSS-VALIDATION NO TENEN
     ftest= "";
     fcost= "";
     ftestcost= "";
   }
   else {
     ftest=argv[optind++];
     if (!argv[optind]) {
       // no hi ha cost ni test cost
       fcost= "";
       ftestcost= "";
     }
     else {
       fcost=argv[optind++];
       if (!argv[optind]) {
         // no hi ha testcost
         ftestcost= "";
       }
       else {
         ftestcost=argv[optind++];
       }
     }
   }
 }

 if (optind != argc) {
    cout << "Extra arguments were specified." << endl;
    usage(argv[0], "");
    exit(-1);
  }

 // Options.SSC= criteri;
 // Options.PC= poda;
//	Options.Multitree.MaxNumTrees= prof;
 // Options.Multitree.BestTreeCrit=bcrit;
   ompli_options(Options);
  }


// TO UPDATE
   void usage(char *prog, char *opt)
{
/* if (opt)
    {
      cerr<< prog<< opt<<endl;
    }  */
  cerr<<"USAGE:" << endl << prog<< " file.train [file.test] [file.cost] [file.testcost]"
  // [-c criterion] [-p method] [-d criterion] [-n trees] [-s method]
  <<endl;
  /*
  cerr<<"    -p method    Criterion used for pre-pruning the tree"<<endl;
  cerr<<"    -c criterion Criterion used for selecting the split to open the tree"<<endl;
  cerr<<"    -d criterion Criterion used for select a solution from the multitree"<< endl;
  cerr<<"    -n trees     Number of trees to be generated in the multitree"<<endl;
  cerr<<"    -s method    Criterion used for combining solutions in the multitree"<<endl;
  */
}

