/***************************************************************************
                          roc.h  -  description
                             -------------------

    functionality        : ROC facilities
    relevant classes     : rank
    relevant functions   : compute_ROC_points, compute_ROC_AREA, genera_ps

    begin                : 10 Dec 2001
    copyright            : (C) 2001 by Cesar Ferri, Jose Hernandez
    email                : {cferri,jorallo}@dsic.upv.es
 ***************************************************************************/

#include "trees.h"
#ifndef ROC_H
#define ROC_H




#define ROC_WITH_TRAIN 0
#define ROC_WITH_TEST 1
#define ROC_WITH_TRAIN_ORDER_TEST_FILL 2

// Specialisations of ROC_WITH_TRAIN
#define ROC_WITH_TRAIN_NO_SMOOTH 3
#define ROC_WITH_TRAIN_PLUS1_SMOOTH 4
#define ROC_WITH_TRAIN_LAPLACE_SMOOTH 5
#define ROC_WITH_TRAIN_SMOOTH_AS_ENABLED_FOR_FREQUENCY 6


void compute_ROC_points(const vector<and_tree *> &solucio,vector<vector<double> > &points, int Roc_With, const options &Options,int ca, int cb);

void compute_ROC_AREA(const vector<vector<double> > &points, double & Area);

void genera_ps(const vector<vector<double> > &points, const char *);

void Compute_Some_Sample_Points_ROC_By_Programa(); // function just to compute areas of roc by hand. Ignore this function


#define MSE_WITH_TRAIN 0
#define MSE_WITH_TEST 1

double compute_AUC_by_Hand(const vector<and_tree *> &solucio, int Roc_With, const options & Options);
double compute_AUC_by_Srinivasan(const vector<and_tree *> &solucio, int Roc_With, const options & Options);
float compute_MSE(const vector<and_tree *> &solucio, const options & Options, int With);
float compute_LogLoss(const vector<and_tree *> &solucio, const options & Options, int With);


struct rank {
 // indext Example;  // LLEVAR
 // float Reliability;  // LLEVAR
  double Rank;
  vector<float> ClassProbVector;
 // discrete Predicted; // LLEVAR
  discrete Real;
 //  bool Correct;  // LLEVAR
};

bool CompareRanks(rank o1, rank o2);
double Compute_AUC_by_Ranks(vector<rank> &RankVector, unsigned long Card, unsigned int i, unsigned int j);

#endif
