/***************************************************************************
                          rules.cpp -  description
                             -------------------

    functionality        : defines basics of rules
    relevant classes     : condition, rule
    relevant functions   :

    begin                : 19 Oct 2001
    copyright            : (C) 2001 by Cesar Ferri, Jose Hernandez
    email                : {cferri,jorallo}@dsic.upv.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "rules.h"
#include "exemples.h"

  void rule::ShowCutre() {
/*    cout << endl;
    for(int i=0; i < Num_arg; i++) {
      cout << i << ":" << (V_condition[i].Operator)
                << ", Byte:" << (int)(V_condition[i].Value).Value_d
                << ", Float:" << (V_condition[i].Value).Value_n;
      cout << endl;
    }
*/
   }

 string rule::ToStringUnfolded(char * FunctionName, const dataset & DataSet, bool Short=false) {
    static char Buf[200];
    strstream s(Buf, 200);
    int NumVar= 0;
    s << FunctionName << "(";
    for(int i=0; i < Num_arg-1; i++) {
      s << "X" << NumVar;
      NumVar++;
      if (i!=Num_arg-2) s << ", ";
    }
    s << ") = R";

    NumVar= 0;
    bool OneCondition= false;
    for(int i=0; i < Num_arg-1; i++) {
      vector<condition> &CondVector= V_condition[i];
      int NumCond= CondVector.size();
      if (NumCond== 0) {
        // do nothing
      }
      else {
      for (int j=0; j<NumCond; j++) {
        if (!OneCondition) {
          s << " :- ";
	     OneCondition= true;
        }
        else s << ", ";
        discrete v;
        if ((CondVector[j].Operator) == CONST_EQ) {
          s << "X" << NumVar << "=" ;
          v= (int)(CondVector[j].Value).Value_d;
          if (Short== true)
            s << v;
          else {
            s << DataSet.NameArgumentValue(i, v) ;
          }
        }
        else if ((CondVector[j].Operator) == CONST_NEQ) {
          s << "X" << NumVar << "!=" ;
          v= (int)(CondVector[j].Value).Value_d;
          if (Short== true)
            s << v;
          else {
            s << DataSet.NameArgumentValue(i, v) ;
          }
        }
        else if ((CondVector[j].Operator) == VAR_EQ) {
          s << "X" << NumVar << "=" << "X" << (int)(CondVector[j].Value).Value_v;
        }
        else if ((CondVector[j].Operator) == VAR_NEQ) {
          s << "X" << NumVar << "!=" << "X" << (int)(CondVector[j].Value).Value_v;
        }
        else if (((CondVector[j].Operator) == NUM_LT) || ((CondVector[j].Operator) == NUM_LT_WU) ) {
          s << "X" << NumVar << "<" << (CondVector[j].Value).Value_n;
        }
        else if (((CondVector[j].Operator) == NUM_GE) || ((CondVector[j].Operator) == NUM_GE_WU)) {
          s << "X" << NumVar << ">=" << (CondVector[j].Value).Value_n;
        }
        else if ((CondVector[j].Operator) == NUM_MISSING) {
          s << "X" << NumVar << "=" << "?";
        }
        else
          cout << "Error en funci ToStringUnFolded: Operador no conegut";
      }
      }
      NumVar++;
    }

    if (V_condition[Num_arg-1].size() != 0) {
      if (V_condition[Num_arg-1][0].Operator == CONST_EQ) {                    // DE MOMENT UNA SOLA CONDICI EN LA CLASSE
        if (OneCondition) s << ", ";
        else s << " :- ";
        s << "R=";
        s << (int)(V_condition[Num_arg-1][0].Value).Value_d;
      }
      else if (V_condition[Num_arg-1][0].Operator == EMPTY)
        ; // No-res
      else
        cout << "Regla amb condicions no permeses per a la classe!";
    }

    s << '.';    // punt com en Prolog. Fi de regla.
    s << '\0';  // fi de cadena
    return string(Buf); // cuidao que igual s'allibera la memoria!!
  }

