/***************************************************************************
                          utils.h  -  description
                             -------------------

    functionality        : some utilities: mathematical and output functions
    relevant classes     :
    relevant functions   : Pause, log2, logbase, Sqr, RandUniform, RandNormal, Compute_Correlation

    begin                : Tue Oct 23 2001
    copyright            : (C) 2001 by Jos Hernndez-Orallo
    email                : jorallo@dsic.upv.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef UTILS_H
#define UTILS_H

#include <cmath>
#include <cstdlib>
#include <iostream>
#include <new>
#include <vector>


inline void Pause(const char *Cad= NULL) {
  if (Cad != NULL)
    cout << endl << Cad;

  cout << endl << "Press a character to continue" << endl;

    char c;
    cin >> c;
}


const double LOGE_2=log(2);

inline float log2(float f) {
  return log(f)/LOGE_2;
}

inline float logbase(float Base, float N) {
  return log(N)/log(Base);
}

inline double Sqr(double d) {
 return d*d;
}

 /*
void f() {
}
*/

#define PI 3.141592654

inline
double RandUniform(double Left, double Right) {
  double x=  rand() / double(RAND_MAX);
  return x*(Right-Left) + Left;
}

inline
double RandNormal(double Mean, double StdDev) {

                double x1, x2, w, y1, y2;



                do {
                        x1 = rand() / double(RAND_MAX);
                        x2 =  rand() / double(RAND_MAX);
                        w = x1 * x1 + x2 * x2;
                } while ( w >= 1.0 );

                y1 = sqrt( - 2 * log(x1) ) * cos( 2 * PI * x2 );
                y2 = sqrt( - 2 * log(x1) ) * sin( 2 * PI * x2 );

                /* //UN ALTRA FORMA EN POLAR
                  // The polar form of the Box-Muller transformation is both faster and more robust numerically. The algorithmic description of it is:
                w = sqrt( (-2.0 * log( w ) ) / w );
                y1 = x1 * w;
                y2 = x2 * w;
                */

      // return y1;
      return y1*StdDev + Mean;
}

const unsigned long TO31=2147483648UL;

// NO FUNCIONA!!!
/*
unsigned long FreeMem() {
  char *p;
  unsigned long i=1, j=0, mid;

 //  new_handler Old_Handler;
 // Old_Handler= set_new_handler(f);

  cout << "First Stage" << endl;
  for (i= 1; i <= TO31; i*=2) {
    cout << i << ":";
    try {
      p= new char[i];
    }
    catch(bad_alloc()) {
      break;
    }
    if (p== NULL) break;
    else delete []p;
    j= i;
  }

  // free memory is between j and i
  cout << "Second Stage" << endl;

  while (i!=j) { // binary search for convergence
    mid= (i+j)/2;
    cout << mid << ":";
    p= new char[mid];
    if (p == NULL) {
      i= mid;
    }
    else {
      delete []p;
      j= mid;
    }
  }

//  set_new_handler(Old_Handler);

  return mid;
}
 */

double Compute_Correlation(vector<double> V1, double Mean1, double Dev1, vector<double> V2, double Mean2, double Dev2);

#endif
